%define section		free

# Note: bootstrap here has a different meaning than in the rh spec
%define bootstrap	0

# custom and bootstrap are incompatible; enable only one or the other.
# FIXME: these are broken in Mandriva's version of rpm!!!
%define custom 0
%define gcjprefix %{nil}
%define origin gcj%{gccsuffix}

%{!?custom:	%define custom 0}
%{!?gcjprefix: 	%define gcjprefix %{nil}}
%{!?origin:	%{expand: %%define origin gcj%{gccsuffix}}}
%define gccsuffix	%{nil}
%define gccsoversion	6
%define priority	1420
%define	javaver		1.4.2
%define buildver	0
# the version-release string for the gcj rpms we require
%define gccver		4.0.1-5mdk
%define jgcver		1.0.40
%define jar		%{_bindir}/fastjar

%if !%{bootstrap}
%define name		java-%{javaver}-%{origin}-compat
%else
%define name		java-%{javaver}-%{origin}-compat-bootstrap
%endif
%define version		%{javaver}.%{buildver}
%define release		%mkrel 40.16
%define cname           java-%{javaver}-%{origin}
#%define bcarchivever	127

%define	sdklnk		java-%{javaver}-%{origin}
%define	jrelnk		jre-%{javaver}-%{origin}
%define	sdkdir		%{cname}-%{version}
%define	jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdklnk}/bin
%define jrebindir	%{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/%{cname}-%{version}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	JPackage runtime scripts for GCJ

Group:		Development/Java
License:	GPL
URL:		ftp://sources.redhat.com/pub/rhug/java-gcj-compat
Source0:	java-gcj-compat-%{jgcver}.tar.bz2
#Source1:        bcprov-jdk14-%{bcarchivever}.tar.gz
%if %{custom}
Source2:	eclipse-ecj-3.1.0_fc-12.jar
%endif
Source3:	ecj.sh.in
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	jpackage-utils >= 0:1.5, sed
BuildRequires:	gcc%{gccsuffix}-java >= 0:%{gccver}
#BuildRequires:	eclipse-ecj
Requires:	gcj%{gccsuffix}-tools
Requires(post):	%{_bindir}/rebuild-security-providers
Requires(postun): %{_bindir}/rebuild-security-providers
%if !%{bootstrap}
Requires:	ecj
Requires:	gjdoc
Requires:	jessie >= 0:1.0.0
Requires:	gnu-crypto >= 0:2.0.1
Requires:	gnu-crypto-sasl-jdk1.4 >= 0:2.0.1
Requires:	gnu-crypto-jce-jdk1.4 >= 0:2.0.1
Requires(post): jpackage-utils >= 0:1.6.3
Requires(postun): jpackage-utils >= 0:1.6.3
Requires(post): gcj%{gccsuffix}-tools
Requires(postun): gcj%{gccsuffix}-tools
%endif
Provides:	jre-%{javaver}-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{javaver}, java-%{javaver}, jre = %{epoch}:%{javaver}
Provides:	java-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java = %{epoch}:%{javaver}
Provides:	jaxp_parser_impl
Provides:	jndi, jndi-ldap, jdbc-stdext, jaas, jta
%if !%{bootstrap}
Provides:	jsse
%endif
Provides:	java-gcj-compat = %{epoch}:%{jgcver}
Provides:	jaxp_transform_impl
%if %{custom}
# prevent autogeneration of libjawt.so dependencies
AutoReqProv:    no
%endif
%if !%{bootstrap}
Obsoletes:	%{name}-bootstrap
Provides:	%{name}-bootstrap
%endif

%description
This package installs directory structures, shell scripts and symbolic
links to simulate a JPackage-compatible runtime environment with GCJ.

%package devel
Summary:	JPackage development scripts for GCJ
Group:		Development/Java
Requires:	/usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}
Provides:	java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}
Provides:	java-sdk = %{epoch}:%{javaver}
Provides:       java-%{javaver}-devel
Provides:	java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{epoch}:%{javaver}
Provides:	java-gcj-compat-devel = %{epoch}:%{jgcver}
Requires:	%{name} = %{epoch}:%{version}-%{release}
%if 0
Obsoletes:	ecj
%else
Requires:	eclipse-ecj
%endif
Requires:	python
Requires:	gcc%{gccsuffix}-java >= 0:%{gccver}
Requires(post):	gcc%{gccsuffix}-java >= 0:%{gccver}

%description devel
This package installs directory structures, shell scripts and symbolic
links to simulate a JPackage-compatible development environment with
GCJ.

%package src
Summary:	Source files for libgcj
Group:		Development/Java
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	libgcj%{gccsoversion}-src >= 0:%{gccver}
Requires(post):	 gcc%{gccsuffix}-java >= 0:%{gccver}
Requires(postun): gcc%{gccsuffix}-java >= 0:%{gccver}

%description src
This package installs a versionless src.zip symlink that points to a
specific version of the libgcj sources.

%prep
%setup -q -n java-gcj-compat-%{jgcver}

%build
export JAR=%{jar}
%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif
%configure --disable-symlinks --with-arch-directory=%{_arch} \
  --with-os-directory=linux \
%if %{custom}
  --with-origin-name=%{origin} \
%endif
  --with-classpath-security=%{_prefix}/lib/security/classpath.security \
  --with-security-directory=%{_sysconfdir}/java/security/security.d
%make

# gzip -dc %{SOURCE1} | tar -xf -
# # build bouncy castle provider
# pushd bcprov-jdk14-%{bcarchivever}/src
#   find -type d -name test | xargs rm -rf
#   ecj `find . -type f -name "*.java"`
#   jar2="bcprov-%{bcarchivever}.jar"
#   files="`find . -type f -name "*.class"`"
#   test ! -d classes && mf="" || mf="`find classes/ -type f -name "*.mf" 2>/dev/null`"
#   test -n "$mf" && fastjar cvfm $jar2 $mf $files || fastjar cvf $jar2 $files
# popd

%if %{custom}
cp -a %{SOURCE2} eclipse-ecj-%{cname}.jar
sed 's:@JAVADIR@:%{_javadir}:g' < %{SOURCE3} > ecj-1
sed 's:eclipse-ecj.jar:eclipse-ecj-%{cname}.jar:g' < ecj-1 > ecj-2
LIBGCJ_JAR="%{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar"
sed "s,compiler.batch.Main,compiler.batch.Main -bootclasspath $LIBGCJ_JAR,g" < ecj-2 > ecj-%{cname}
%endif

%if 0
mkdir tmp
cp -a %{SOURCE2} eclipse-ecj.jar
%ifnarch ia64
mv eclipse-ecj.jar tmp
# close your eyes...
RPM_BUILD_ROOT=tmp python aot-compile-rpm
mv tmp/eclipse-ecj.jar tmp%{_libdir}/gcj/%{name}/* .
# (you can open them again now)
%endif
sed 's:@JAVADIR@:%{_javadir}:g' < %{SOURCE3} > ecj
%endif

%install
%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

%if %{custom}
ln -sf %{_bindir}/ecj-%{cname} $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin/javac
%endif

# create extensions symlinks
# jessie
%if !%{bootstrap}
ln -s %{_javadir}/jsse.jar $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/jsse.jar
%else
rm -f $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin/javadoc
%endif

# extensions handling
install -dm 755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
   ln -s %{_jvmdir}/%{jredir}/lib/jaas.jar jaas-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/jdbc-stdext.jar jdbc-stdext-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/jndi.jar jndi-%{version}.jar
%if !%{bootstrap}
   ln -s %{_jvmdir}/%{jredir}/lib/jsse.jar jsse-%{version}.jar
%endif
   for jar in *-%{version}.jar ; do
     ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
     ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

# security directories
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/security

# default security provider, provided by libgcj
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d
%if !%{bootstrap}
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/1000-gnu.java.security.provider.Gnu
# touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/2000-org.bouncycastle.jce.provider.BouncyCastleProvider
%endif

# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
   ln -s %{jredir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

pushd $RPM_BUILD_ROOT%{_jvmjardir}
   ln -s %{sdkdir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed 's|'$RPM_BUILD_ROOT'|%dir |' >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed 's|'$RPM_BUILD_ROOT'||'      >> %{name}-%{version}-all.files

cat %{name}-%{version}-all.files \
  > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -type f -o -type l \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files

# # install bouncy castle provider
# install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
# install -pm 644 bcprov-jdk14-%{bcarchivever}/src/bcprov-%{bcarchivever}.jar \
#   $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/bcprov-%{bcarchivever}.jar

# classmap database directory
install -dm 755 $RPM_BUILD_ROOT%{_libdir}/gcj

%if %{custom}
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m644 eclipse-ecj-%{cname}.jar $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m755 ecj-%{cname} $RPM_BUILD_ROOT%{_bindir}
%endif

%if 0
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m644 eclipse-ecj.jar $RPM_BUILD_ROOT%{_javadir}
%ifnarch ia64
mkdir -p $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m755 eclipse-ecj.jar.so $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m644 eclipse-ecj.jar.db $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
%endif
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m755 ecj $RPM_BUILD_ROOT%{_bindir}
%endif

cat > rebuild-security-providers << EOF
#!/bin/sh
# Rebuild the list of security providers classpath.security

cat %{_prefix}/lib/security/classpath.security \
  | grep -v "^security.provider." \
  > %{_prefix}/lib/security/classpath.security.bak
mv -f %{_prefix}/lib/security/classpath.security.bak \
  %{_prefix}/lib/security/classpath.security

providers=\$(ls %{_sysconfdir}/java/security/security.d | sort \
  | awk -F- '{ print \$2 }')
count=0
for provider in \$providers
do
  count=\$((count + 1))
  echo "security.provider."\$count"="\$provider \
    >> %{_prefix}/lib/security/classpath.security
done
EOF

mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 rebuild-security-providers $RPM_BUILD_ROOT%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%post

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

update-alternatives \
  --install %{_bindir}/java java %{jrebindir}/java %{priority} \
  --slave %{_jvmdir}/jre          jre          %{_jvmdir}/%{jrelnk} \
  --slave %{_jvmjardir}/jre       jre_exports  %{_jvmjardir}/%{jrelnk} \
  --slave %{_bindir}/rmiregistry  rmiregistry  %{jrebindir}/rmiregistry \
  --slave %{_bindir}/rebuild-gcj-db  rebuild-gcj-db  %{jrebindir}/rebuild-gcj-db

update-alternatives \
  --install %{_jvmdir}/jre-%{origin} \
      jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{origin} \
      jre_%{origin}_exports %{_jvmjardir}/%{jrelnk}

update-alternatives \
  --install %{_jvmdir}/jre-%{javaver} \
      jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{javaver} \
      jre_%{javaver}_exports %{_jvmjardir}/%{jrelnk}

# rt.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar

# jaas.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jaas.jar

# jdbc-stdext.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jdbc-stdext.jar

# jndi.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jndi.jar

# java.security
ln -sf \
  %{_prefix}/lib/security/classpath.security \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/security/java.security

%{_bindir}/rebuild-security-providers

%if %{custom}
# jaxp_parser_impl
update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
  jaxp_parser_impl \
  %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
# jaxp_parser_impl
update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
  jaxp_parser_impl \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif

%if %{custom}
# jaxp_transform_impl.jar
update-alternatives --install %{_javadir}/jaxp_transform_impl.jar \
  jaxp_transform_impl \
  %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
# jaxp_transform_impl
update-alternatives --install %{_javadir}/jaxp_transform_impl.jar \
  jaxp_transform_impl \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif

%post devel

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

update-alternatives \
  --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
  --slave %{_jvmdir}/java     java_sdk          %{_jvmdir}/%{sdklnk} \
  --slave %{_jvmjardir}/java  java_sdk_exports  %{_jvmjardir}/%{sdklnk} \
%if !%{bootstrap}
  --slave %{_bindir}/javadoc  javadoc           %{sdkbindir}/javadoc \
%endif
  --slave %{_bindir}/javah    javah             %{sdkbindir}/javah \
  --slave %{_bindir}/jar      jar               %{sdkbindir}/jar \
  --slave %{_bindir}/rmic     rmic              %{sdkbindir}/rmic \
  --slave %{_bindir}/aot-compile-rpm aot-compile-rpm %{sdkbindir}/aot-compile-rpm

update-alternatives \
  --install %{_jvmdir}/java-%{origin} \
      java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{origin} \
      java_sdk_%{origin}_exports %{_jvmjardir}/%{sdklnk}

update-alternatives \
  --install %{_jvmdir}/java-%{javaver} \
      java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{javaver} \
      java_sdk_%{javaver}_exports %{_jvmjardir}/%{sdklnk}

# jni.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jni.h` \
  %{_jvmdir}/%{cname}-%{version}/include/jni.h

# jni_md.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jni_md.h` \
  %{_jvmdir}/%{cname}-%{version}/include/linux/jni_md.h

# jawt.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jawt.h` \
  %{_jvmdir}/%{cname}-%{version}/include/jawt.h

# jawt_md.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jawt_md.h` \
  %{_jvmdir}/%{cname}-%{version}/include/linux/jawt_md.h

%post src

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

# src.zip
ln -sf \
  %{_javadir}/src-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.zip \
  %{_jvmdir}/%{cname}-%{version}/src.zip

%postun
if [ $1 -eq 0 ] ; then

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

   update-alternatives --remove java %{jrebindir}/java
   update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jrelnk}
   update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jrelnk}
%if %{custom}
   update-alternatives --remove jaxp_parser_impl \
     %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%else
   update-alternatives --remove jaxp_parser_impl \
     %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%endif
%if %{custom}
   update-alternatives --remove jaxp_transform_impl \
     %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%else
   update-alternatives --remove jaxp_transform_impl \
     %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%endif
fi

%{_bindir}/rebuild-security-providers

%postun devel
if [ $1 -eq 0 ] ; then

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

   update-alternatives --remove javac %{sdkbindir}/javac
   update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
   update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

%triggerin -- libgcj%{gccsoversion} > 0:%{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  # rt.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar

  # jaas.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jaas.jar

  # jdbc-stdext.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jdbc-stdext.jar

  # jndi.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jndi.jar

%if %{custom}
  # jaxp_parser_impl
  update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
    jaxp_parser_impl \
    %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
  # jaxp_parser_impl
  update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
    jaxp_parser_impl \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif

%if %{custom}
  # jaxp_transform_impl
  update-alternatives --install %{_javadir}/jaxp_transform_impl.jar \
    jaxp_transform_impl \
    %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
  # jaxp_transform_impl
  update-alternatives --install %{_javadir}/jaxp_transform_impl.jar \
    jaxp_transform_impl \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif
} || :

# gcc-java requires libgcj-devel which provides jni.h
%triggerin devel -- gcc%{gccsuffix}-java > 0:%{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  # jni.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jni.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jni.h

  # jni_md.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jni_md.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jni_md.h

  # jawt.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jawt.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jawt.h

  # jawt_md.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jawt_md.h` \
    %{_jvmdir}/%{cname}-%{version}/include/linux/jawt_md.h
} || :

%triggerin src -- libgcj%{gccsoversion}-src >= 0:%{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  ln -sf \
    %{_javadir}/src-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.zip \
    %{_jvmdir}/%{cname}-%{version}/src.zip
} || :

%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%{_bindir}/rebuild-security-providers
%dir %{_libdir}/gcj
%doc
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
#%{_jvmprivdir}/*
%if !%{bootstrap}
%config(noreplace) %{_sysconfdir}/java/security/security.d/1000-gnu.java.security.provider.Gnu
%endif
# %{_javadir}/gcj-endorsed/bcprov-%{bcarchivever}.jar
# %config(noreplace) %{_sysconfdir}/java/security/security.d/2000-org.bouncycastle.jce.provider.BouncyCastleProvider
%dir %{_sysconfdir}/java/security
%dir %{_sysconfdir}/java/security/security.d

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root)
%doc
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}
%if %{custom}
%{_bindir}/ecj-%{cname}
%{_javadir}/eclipse-ecj-%{cname}.jar
%endif
%if 0
%{_bindir}/ecj
%ifnarch ia64
%{_libdir}/gcj/%{name}
%endif
%{_javadir}/eclipse-ecj.jar
%endif

%files src
%defattr(-,root,root)

%changelog
* Tue Sep 06 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.16mdk
- use %%mkrel
- don't add provider file if %%bootstrap is 1

* Tue Sep 06 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.15mdk
- add %%{_sysconfdir}/java/security and %%{_sysconfdir}/java/security.d as %%dir

* Tue Sep 06 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.14mdk
- update bootstrap
- add gcj-specific files from jpackage-utils

* Fri Sep 02 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.13mdk
- sync with 40jpp_47rh and java-gcj-compat 1.0.40
- don't provide jndi-ldap or jta

* Thu Jul 28 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.12mdk
- sync with 40jpp_43rh and java-gcj-compat 1.0.36
- provides jndi-ldap
- use alternatives for jaxp_parser_impl and jaxp_transform_impl
- don't provide java-javadoc (use, e.g., classpath javadocs instead)

* Sat Jun 25 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 0:1.4.2.0-40.11mdk
- gcc 4.0.1

* Fri Jun 10 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.10mdk
- sync with 40jpp_30rh and java-gcj-compat 1.0.30

* Thu May 19 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.9mdk
- export jaxp_parser_impl.jar and jaxp_transform_impl.jar

* Thu May 19 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.8mdk
- add symlink to jaxp_parser_impl.jar
- provide jaxp_transform_impl and add symlink to jaxp_transform_impl.jar

* Tue May 17 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.7mdk
- add requires on %%{_bindir}/rebuild-security-providers (fixes bug #16023)

* Wed May 11 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.6mdk
- rebuild as non-bootstrap

* Mon May 09 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.5mdk
- fix src dependency, but don't require it (yet)

* Mon May 09 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.4mdk
- provide java-javadoc
- don't require on gcc-java release

* Sat May 07 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.3mdk
- provide java-%%{javaver}-javadoc

* Sat May 07 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.2mdk
- fix symlinks and bin locations
- fix group

* Tue May 03 2005 David Walluck <walluck@mandriva.org> 0:1.4.2.0-40.1mdk
- release

* Fri Apr 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_18rh
- Require gnu-crypto.

* Fri Apr 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_17rh
- Provide jaxp_parser_impl.

* Wed Apr 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_16rh
- Import java-gcj-compat 1.0.28.

* Mon Apr  4 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_15rh
- Import java-gcj-compat 1.0.27.
- Bump gccver to 4.0.0-0.39.
- Make -devel take ownership of symlinks as well as regular files.

* Wed Mar 30 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_14rh
- Import java-gcj-compat 1.0.23.
- Always look for classpath.security in /usr/lib. (151561)
- Provide jsse. (151662)

* Thu Mar 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_13rh
- Uncomment rebuild-security-providers.
- Require jessie >= 1.0.0-3.

* Tue Mar 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_12rh
- Don't re-run rebuild-security-providers.

* Tue Mar 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_11rh
- Add jaas and jta provides.

* Tue Mar  8 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_10rh
- Import java-gcj-compat 1.0.22.
- Symlink jaas.jar, jdbc-stdext.jar, jndi.jar and jta.jar to
  libgcj.jar.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_9rh
- Import java-gcj-compat 1.0.21.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_8rh
- Import java-gcj-compat 1.0.20.
- Depend on jessie.
- Install jsse.jar.
- Install security directory.
- Symlink classpath.security to java.security.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_7rh
- Import java-gcj-compat 1.0.19.

* Thu Mar  3 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_6rh
- Import java-gcj-compat 1.0.18.

* Thu Mar  3 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_5rh
- Update descriptions.

* Wed Mar  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_4rh
- Bump release number.

* Wed Mar  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_3rh
- Make java-1.4.2-gcj-compat-devel obsolete java-1.4.2-gcj4-compat-devel.
- Import java-gcj-compat 1.0.17.
- Specify --with-arch-directory and --with-os-directory options on
  configure line.

* Tue Mar  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_2rh
- Make arch-specific.

* Tue Mar  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_1rh
- Merge java-1.4.2-gcj4-compat into java-1.4.2-gcj-compat.
- Import java-gcj-compat 1.0.15.
- Add AWT Native Interface symlinks.
- Remove build requires on eclipse-ecj.

* Thu Feb 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_4rh
- Add -src sub-package.

* Wed Feb  9 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_3rh
- Import java-gcj-compat 1.0.14.

* Tue Feb  8 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_2rh
- Import java-gcj-compat 1.0.13.

* Mon Feb  7 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_1rh
- Import java-gcj-compat 1.0.12.

* Wed Feb  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_1rh
- Add Red Hat release number.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Remove gjdoc version requirement.
- Change java-gcj-compat version number.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Import java-gcj-compat 1.0.11.
- Require gjdoc.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Add jni.h symlink.
- Install rt.jar as an unmanaged symlink.
- Conflict and obsolete old java-gcj-compat rpms.
- Import java-gcj-compat 1.0.9.

* Mon Jan 24 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-3jpp
- Import java-gcj-compat 1.0.8.

* Thu Jan 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-2jpp
- Make jvmjardir use cname, not name.

* Wed Jan 12 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Initial build.
